/*
 * Ping Pong test classes for Jada
 *
 * Refer to jada.html to know hot to use this file.
 *
 * (C) 1996 Davide Rossi
 */

import jada.tuple.*;
import jada.client.TupleClient;
import java.applet.Applet;
import java.awt.List;

class Ping implements Runnable {
	//the tuple space
	TupleSpace tuple_space=null;

	public Ping(TupleSpace ts) {
		tuple_space=ts;
	}

	/*
	 * the basic in-out loop, we use different Tuple contructors here
	 */
	public void run() {
		while(true) {
			//this tuple matches with any tuple having "ping" as first item
			//and an instance of the class Integer as second one
			Tuple in=tuple_space.in(new Tuple("ping", new Integer(0).getClass()));
			//get the int vaue of the second field for the tuple returned by in
			int cnt=((Integer)in.getItem(1)).intValue();
			//puts a new tuple into the tuple space
			tuple_space.out(new Tuple("pong", new Integer(cnt+1)));
			System.out.println(in);
		}
	}

	public static void main(String args[]) {
		TupleClient tuple_space=null;

		//if one arg exists it should be the tuple server host address
		if(args.length==1) {
			tuple_space=new TupleClient(args[0]);
		} else {
			tuple_space=new TupleClient();
		}
		new Ping(tuple_space).run();
	}
}

class Pong implements Runnable {
	//the tuple space
	TupleSpace tuple_space=null;

	public Pong(TupleSpace ts) {
		tuple_space=ts;
	}

	public void run() {
		while(true) {
			//now we use a Tuple.I() wich return exacty the same as
			//new Integer(0).getClass() but is much shorter to write :)
			Tuple in=tuple_space.in(new Tuple("pong", Tuple.I()));
			int cnt=((Integer)in.getItem(1)).intValue();
			tuple_space.out(new Tuple("ping", new Integer(cnt+1)));
			System.out.println(in);
		}
	}

	public static void main(String args[]) {
		TupleClient tuple_space=null;

		//if one arg exists it should be the tuple server host address
		if(args.length==1) {
			tuple_space=new TupleClient(args[0]);
		} else {
			tuple_space=new TupleClient();
		}
		tuple_space.out(new Tuple("ping", new Integer(0)));
		new Pong(tuple_space).run();
	}
}

class PingPong {
	public static void main(String args[]) {
		//create a new (local) tuple space
		TupleSpace tuple_space=new TupleSpace();
		//run the ping thread
		new Thread(new Ping(tuple_space)).start();
		//run the pong thread
		new Thread(new Pong(tuple_space)).start();
		//put a first item in the tuple space
		tuple_space.out(new TupleString("(ping, 0)"));
	}
}